/*
 * Copyright COCKTAIL (www.cocktail.org), 1995, 2012 This software 
 * is governed by the CeCILL license under French law and abiding by the
 * rules of distribution of free software. You can use, modify and/or 
 * redistribute the software under the terms of the CeCILL license as 
 * circulated by CEA, CNRS and INRIA at the following URL 
 * "http://www.cecill.info". 
 * As a counterpart to the access to the source code and rights to copy, modify 
 * and redistribute granted by the license, users are provided only with a 
 * limited warranty and the software's author, the holder of the economic 
 * rights, and the successive licensors have only limited liability. In this 
 * respect, the user's attention is drawn to the risks associated with loading,
 * using, modifying and/or developing or reproducing the software by the user 
 * in light of its specific status of free software, that may mean that it
 * is complicated to manipulate, and that also therefore means that it is 
 * reserved for developers and experienced professionals having in-depth
 * computer knowledge. Users are therefore encouraged to load and test the 
 * software's suitability as regards their requirements in conditions enabling
 * the security of their systems and/or data to be ensured and, more generally, 
 * to use and operate it in the same conditions as regards security. The
 * fact that you are presently reading this means that you have had knowledge 
 * of the CeCILL license and that you accept its terms.
 */
package org.cocktail.carambole.server.components;

// Generated by the WOLips Templateengine Plug-in at 25 juin 2007 07:00:36

import org.cocktail.carambole.server.MyComponent;
import org.cocktail.fwkcktldepense.server.finder.FinderCommande;
import org.cocktail.fwkcktldepense.server.finder.FinderDepensePapier;
import org.cocktail.fwkcktldepense.server.metier.EOCommande;
import org.cocktail.fwkcktldepense.server.metier.EODepensePapier;
import org.cocktail.fwkcktldepense.server.metier.EOExercice;

import com.webobjects.appserver.WOComponent;
import com.webobjects.appserver.WOContext;
import com.webobjects.eocontrol.EOEditingContext;
import com.webobjects.foundation.NSArray;
import com.webobjects.foundation.NSDictionary;

import er.extensions.eof.ERXEC;

public class LiquidationApresEnregistrement extends MyComponent {

	private static final long serialVersionUID = 1L;

	public LiquidationApresEnregistrement(WOContext context) {
		super(context);
	}

	public WOComponent afficherDetail() {
		WOComponent nextPage = null;
		EOCommande commande = laCommandeEnCours();
		if (commande != null) {
			nextPage = (DetailCommande) pageWithName(DetailCommande.class.getName());
			EOEditingContext edc = commande.editingContext();
			EOEditingContext newEdc = ERXEC.newEditingContext();
			EOExercice exercice = (EOExercice) newEdc.faultForGlobalID(edc.globalIDForObject(commande.exercice()), newEdc);
			Number numero = commande.commNumero();
			commande = FinderCommande.getCommande(newEdc, exercice, numero);
			session.setLaCommandeEnCours(commande);
			if (commande != null) {
				((DetailCommande) nextPage).setLaCommande(commande);
				session.setLaDepensePapierEnCours(null);
				session.setNestedEdc(newEdc);
			}
			else {
				nextPage = accueil();
			}
		}
		return nextPage;
	}

	public WOComponent afficherDetailFacture() {
		DetailFacture nextPage = (DetailFacture) pageWithName(DetailFacture.class.getName());
		//		EODepensePapier dp = laDepensePapierEnCours();
		//		EOEditingContext newEdc = ERXEC.newEditingContext();
		//		Number cle = dp.dppIdProc();
		//		if (cle != null) {
		//			NSArray<EODepensePapier> dps = FinderDepensePapier.getDepensePapierPourNumeroFacture(newEdc, new NSDictionary<String, Object>(cle, "cle"));
		//			if (dps != null && dps.count() == 1) {
		//				dp = (EODepensePapier) dps.lastObject();
		//			}
		//		}
		EODepensePapier dp = dpp();
		nextPage.setLaFacture(dp);
		session.setLaDepensePapierEnCours(dp);
		if (dp.depenseBudgets().count() == 1) {
			session.setLEngagementBudgetEnCours(dp.depenseBudgets().objectAtIndex(0).engagementBudget());
		}
		else {
			session.setLEngagementBudgetEnCours(null);
		}

		session.setLaCommandeEnCours(dp.commandeassociee());
		return nextPage;
	}

	public WOComponent afficherDetailEngagement() {
		DetailEngagementBudget nextPage = (DetailEngagementBudget) pageWithName(DetailEngagementBudget.class.getName());
		//		EODepensePapier dp = laDepensePapierEnCours();
		//		EOEditingContext newEdc = ERXEC.newEditingContext();
		//		Number cle = dp.dppIdProc();
		//		if (cle != null) {
		//			NSArray<EODepensePapier> dps = FinderDepensePapier.getDepensePapierPourNumeroFacture(newEdc, new NSDictionary<String, Object>(cle, "cle"));
		//			if (dps != null && dps.count() == 1) {
		//				dp = (EODepensePapier) dps.lastObject();
		//			}
		//		}
		EODepensePapier dp = dpp();
		session.setLaDepensePapierEnCours(dp);
		session.setLaCommandeEnCours(dp.commandeassociee());
		if (dp.depenseBudgets().count() == 1) {
			session.setLEngagementBudgetEnCours(dp.depenseBudgets().objectAtIndex(0).engagementBudget());
		}
		else {
			return accueil();
		}
		return nextPage;
	}

	private EODepensePapier dpp() {
		EODepensePapier dp = laDepensePapierEnCours();
		EOEditingContext newEdc = ERXEC.newEditingContext();
		Number cle = dp.dppIdProc();
		if (cle != null) {
			NSArray<EODepensePapier> dps = FinderDepensePapier.getDepensePapierPourNumeroFacture(newEdc, new NSDictionary<String, Object>(cle, "cle"));
			if (dps != null && dps.count() == 1) {
				dp = (EODepensePapier) dps.lastObject();
			}
		}
		return dp;
	}

	public WOComponent accueil() {
		Accueil nextPage = (Accueil) pageWithName(Accueil.class.getName());
		nextPage.reset();
		return nextPage;
	}

	public Boolean isEngageDetailAffichable() {
		return null;
	}
}